// display

// the following lines is supposed(optional) to replace a single line in sketch, the #include"Esp8266MyWiFiUnified.h".
// For the following macros copied to main for easy modify. So, copy these to there and uncomment it could simply done.
#ifndef _ESP8266_MY_WIFI_UNIFIED_DISABLEH_
#define _ESP8266_MY_WIFI_UNIFIED_DISABLEH_
#include <ESP8266WiFi.h>

////////////////// paste the macros here (which is between IoT BEGIN/END .h) //////////////////
// ************************** IoT BEGIN .h ******************************
// ========================== Options and Defs/modify if need ==============================
// -------------------------- for AP or STA ------------------------------
// 1 for ap, 0 for sta.
#define AP_MODE 0
#define STA_MODE (!AP_MODE)

// -------------------------- for ap/sta credential ------------------------------ comment it and put it in .cpp
#if 1
const char *const WIFI_CRED[][2]={
    {"ESP_TESTAP", "87654321"},
    {"Office", "123456"},
    {"Xperia X Performance_bc10", "e848acbcfd98"},
};
#endif // if 1

// -------------------------- for part of hostname ------------------------------
#define LSERVICE_1 "display"
#define LPSERVICE_1 80

// -------------------------- for default connection names ------------------------------
// i.e., http://hostname.local/
#define HOSTNAME_BASE "esp8266-iot" // for local used.
#define HOSTNAME ((String(HOSTNAME_BASE)+"-"+LSERVICE_1).c_str()) // for local used.
#define REMOTE_HOSTNAME "esp8266-iot-internet" // for remote use.

#define UPDFILE "a.bin" // the remote webpage for updating to local is http://REMOTE_HOSTNAME.local/upd

// -------------------------- other settings ------------------------------
#define HTTPC_GET_DELAY delay(25) // do the delay after an HTTP GET.
#define HTTPC_GET_PROC_DELAY delay(5) // do some delay during an HTTP GET course.
#define HTTPC_CONN_TIMEOUT 3000 // the timeout during a GET, 3000ms.

// all the TMO values is restricted to no more than 35 minutes; see the Timeout() for detail. however,
// cascading could overcome.
#define TMO_IOT_LOOP_PERIOD 75 // IoT polling at each 75ms
#define TMO_AP_C_CONN_PERIOD 30000 // each 30 seconds to show connections by AP
#define TMO_STA_CONN_HEALTH_PERIOD 20000 // each 20 seconds to check the connection health by STA(while ping is alive)
#define TMO_WEB_UPDATE_PERIOD (1000*60*30) // each 30 minutes to find internet update; if cascade twice(no, use count) will become 15hr
#define TMO_MDNS_Q_PERIOD 60000 // each 60 seconds to query services
#define TMO_PING_PERIOD 6000 // each 3 seconds to ping AP when ping failed

#define STA_RECOVER_ALIVE 0 // set 0 if STA connection broken and do not reconnect. 1 to reconnect.

// [mDns] use either of one
#define USE_MDNS_STANDALONE // no auto hostname
//#define USE_MDNS_FULL // auto hostname and query

// [STAtion] use either of one
//#define USE_STA_NATIVE // single AP
#define USE_STA_WIFI_MULTI // multiple APs(o)

// [HTTPClient] use either of one
//#define USE_HTTPC_HTTP_CLIENT
//#define USE_HTTPC_WIFI_CLIENT
#define USE_HTTPC_WIFIHTTP_HYBRID // (o2)
//#define USE_HTTPC_WIFIHTTP_HYBRID_NONBLOCKING // (o1)

// -------------------------- for mdns ------------------------------
typedef struct smDnsRecord{
    const char *service;
    const unsigned port;
} smDnsRecord;

// -------------------------- for mdns services ------------------------------ comment it and put it in .cpp
#if 1
#if defined(USE_MDNS_FULL)
const smDnsRecord mdns_ss[]={ // the services this device provides; note, at least the LSERVICE_1 has already provided.
    {"display", 80},
    {"iot", 80},
    {"https", 443},
    {"test", 81},
    {"motor", 80},
};
#endif // USE_MDNS_FULL

const smDnsRecord mdns_sskn[]={ // the known services this device needs from other devices.
    {"display", 80},
    {"iot", 80},
    {"https", 443},
    {"test", 81},
    {"motor", 80},
};
#endif // if 1


// ************************** IoT END .h ******************************
////////////////// paste the macros here (which is between IoT BEGIN/END .h) //////////////////

#include"Esp8266MyWiFiUnified.h"
#endif // _ESP8266_MY_WIFI_UNIFIED_DISABLEH_


#include <U8g2lib.h>
/////#include"Esp8266MultiPwms.h"
#include"Esp8266Vars2File.h"


#define VERSION_202104270001 "[[202104270001][AP/STA][ESP_TESTAP:87654321][esp8266-iot-display:80][esp8266-iot-internet][upd:a.bin]"\
            "[MDNS:FIXED][WeMos TTGO][115200:160:26:4M:3MFS:512KSK:80M]]" // so the version number is the 3rd byte, length 12.


String web_link, ap_mode_speed_str;


// ------------------------------------ for periodically u8g2 drawing
#define DRAW_INT_GPIO           0
#define DRAW_TRG_GPIO           0
#define DRAW_PERIOD_PRE         900/////900000 // 900ms. less than 600ms will wdt-reset when sta mode in connecting.
#define DRAW_PERIOD             100/////100000 // 100ms. less than 100ms will wdt-reset when ap mode.

// ------------------------ joystick
#define MUX_S0_GPIO             12
#define MUX_S1_GPIO             13

#define BUTTON_GPIO             5

#define VOLTAGE_REAL            14.5f
#define VOLTAGE_TRAN            3.248f
#define VOFFSET                 17
#define BVOLTAGE(x)             (((x)>VOFFSET? (x)-17: 0)*(3.3f/VOLTAGE_TRAN*VOLTAGE_REAL/1024.f))

// mux s2=gnd, s1=gpio13, s0=gpio12, use a0, a1, a2, a3 for y, x, button, battery.


// ------------------------------------ u8g2 config
#define OLED_SDA  2
#define OLED_SCL 14
#define OLED_RST  4
U8G2_SSD1306_128X32_UNIVISION_F_SW_I2C u8g2(U8G2_R0, OLED_SCL, OLED_SDA , OLED_RST);
const char *text = "U8g2";
char str1[17];
unsigned dir1=0;

// a null-terminated string already in an frmsz-size frm-frame with or without leading spaces will be wiggling in it.
// dir stores 0(forward) or 1(backward, non-zero) represents current direction which will be auto reversed.
void TextInFrameWiggle(unsigned &dir, byte frmsz, char *frm){
  
  for (int i=0, j=0; i<frmsz; i++){
    if (frm[i]!=' '){ // find the 1st non-space character incl. 0
      if (dir){ // backward
        if (i){
          do {frm[i-1]=frm[i];} while (frm[i++]);
          return;
        }
        else dir=0;
      }

      // forward
      j=i;
      while (frm[j++]);
      if (j-i==frmsz) return; // means no-leading-space string occupies entire frame
      if (j==frmsz){ // time to turnaround
        --i;
        dir=1;
        continue;
      }
      do {frm[j]=frm[j-1];} while (--j!=i);
      frm[j]=' ';
      return;
    }
  }
}

void setup_u8g2() {
  u8g2.begin();
  strcpy(str1, text);
}

void loop_u8g2_welcome(){
    u8g2.drawStr(0, 10, "Welcome, Please");
    u8g2.drawStr(0, 20, "press the button");
    u8g2.drawStr(0, 30, "to continue...");
}

void loop_u8g2_powerdown(){
    u8g2.drawStr(0, 10, " ");
}

void loop_u8g2_0(){
    if (!is_station_mode_established) u8g2.drawStr(0,28,"connecting...");
}

void loop_u8g2_1(){
    TextInFrameWiggle(dir1, 17, str1);
    u8g2.drawStr(0,10,str1);
}

void loop_u8g2_2(){
    static String pr="";
    if (http_got_str!="" && pr!=http_got_str){
        pr=http_got_str;
    }

#if AP_MODE
    pr=ap_mode_speed_str;
#endif

    if (pr!="") u8g2.drawStr(0,28,pr.c_str());

}

void loop_u8g2_3(){ // output the joystick values
    extern unsigned joystick[], joystick_tri[];
    u8g2.drawStr(0, 28, (String(BVOLTAGE(joystick[3]))+" "+joystick_tri[1]+" "+joystick_tri[0]+" "+joystick_tri[2]).c_str());
}


typedef struct sFooLinkedList{
    void (*fp)();
    sFooLinkedList *next;
    sFooLinkedList(): fp(0), next(0){;};
    ~sFooLinkedList(){delete this->next;};
} sFooLinkedList;

/////cHwTimer timer_draw_manip; // be aware that hwtimer1 must bring up first.
/////IRAM_ATTR unsigned timer_trigger=0;
/////IRAM_ATTR void isr_draw_manip_timer(){digitalWrite(DRAW_TRG_GPIO, timer_trigger^=1);}
IRAM_ATTR unsigned DrawSubmit=0; // set 1 to start drawing
IRAM_ATTR unsigned AutoDrawSubmit=0; // set 1 to start auto drawing
sFooLinkedList *draw_link=0;
unsigned joystick_old[4];
unsigned joystick[4];
unsigned joystick_tri[4];
unsigned joystick_alive=0;

unsigned the_draw_period=0;

void DrawSetup(){
    /////pinMode(DRAW_TRG_GPIO, OUTPUT); // this gpio is to trigger intr gpio
    /////digitalWrite(DRAW_TRG_GPIO, LOW);
    /////attachInterrupt(digitalPinToInterrupt(DRAW_INT_GPIO), isr_draw_manip, CHANGE);

#if AP_MODE
    /////timer_draw_manip.setTimer(DRAW_PERIOD, isr_draw_manip_timer);
    the_draw_period=DRAW_PERIOD;/////
#else
    /////timer_draw_manip.setTimer(DRAW_PERIOD_PRE, isr_draw_manip_timer);
    the_draw_period=DRAW_PERIOD_PRE;/////
#endif
}

void DrawConfig(void (*fptr)()){ // insert function pointers to which draw the buffer.
    if (!draw_link){
        draw_link=new sFooLinkedList;
        draw_link->fp=fptr;
        return;
    }
    sFooLinkedList *a_link=draw_link;
    while (a_link->next) a_link=a_link->next;
    a_link->next=new sFooLinkedList;
    a_link->next->fp=fptr;
}

IRAM_ATTR void isr_draw_manip(){
    if (DrawSubmit==1){
        DrawSubmit=2;
        u8g2.clearBuffer();
        u8g2.setFont(u8g2_font_8x13B_mf);
        sFooLinkedList *a_link=draw_link;
        while (a_link){
            if (a_link->fp) (a_link->fp)();
            a_link=a_link->next;
        }
        u8g2.sendBuffer();
        DrawSubmit=0;
    }
    if (AutoDrawSubmit) DrawSubmit=1;

    // joystick sampling. CD74HC4051E Mux.
    // a0, a1, a2, a3 for y, x, button, battery.
    extern unsigned joystick_old[4];
    extern unsigned joystick[4];
    extern unsigned joystick_tri[4];

    static unsigned pn=0;
    digitalWrite(MUX_S0_GPIO, pn&0x1);
    digitalWrite(MUX_S1_GPIO, (pn>>1)&0x1);
    delayMicroseconds(1);
    joystick[pn]=analogRead(A0);

    if (joystick[2]>100){ // the joystick is now working

        switch (pn){
            case 0: // y
                if (joystick[0]<400){
                    joystick_tri[0]+=((joystick_tri[0]&0x1)? 2: 1); // odd if dir=-y.
                    joystick_alive=1;
                }
                else if (joystick[0]>600){
                    joystick_tri[0]+=((joystick_tri[0]&0x1)? 1: 2); // even if dir=+y.
                    joystick_alive=1;
                }
                break;
            case 1: // x
                if (joystick[1]<400){
                    joystick_tri[1]+=((joystick_tri[1]&0x1)? 2: 1); // odd if dir=-x.
                    joystick_alive=1;
                }
                else if (joystick[1]>600){
                    joystick_tri[1]+=((joystick_tri[1]&0x1)? 1: 2); // even if dir=+x.
                    joystick_alive=1;
                }
                break;
            case 2: // button. this implement must let user press the button once first,
                    // else it will increase continuously; use this behavior to decide user did press or not.
                if (joystick[2]>joystick_old[2]+12){ // caught the make code and renew
                    joystick_old[2]=joystick[2];
                    joystick_tri[2]++;
                    joystick_alive=1;
                }
                else if (joystick_old[2]>7 && joystick[2]>joystick_old[2]-7){ // caught the make code
                    joystick_tri[2]++;
                    joystick_alive=1; // if do not press the button, it will always keep alive.
                }
                else if (joystick_old[2]>12 && joystick[2]<joystick_old[2]-12) joystick_old[2]-=2; // renew for bat decreasing.
                break;
            case 3: // battery voltage, low detection.
                // around the battery voltage detection of 3.45V, the LDO will output 2.63V and can not boot up.
                // so the threshold sould be 3.7V(LDO 2.9V).
                joystick[3]=joystick_old[3]*0.8f+joystick[3]*0.2f;
                joystick_old[3]=joystick[3];
                if (BVOLTAGE(joystick[3])<3.7f){ // battery low
                    joystick_tri[3]++;
                }
                break;
        }

    }

    if (++pn>3) pn=0;
}

void DrawEnd(){ // must called if do not draw anymore
    delete draw_link;
    draw_link=0;
}


// ------------------------------------ http
void my_http_request(){ // called only if http_request_ip assigned.
    static unsigned tmo=micros();
    if (Timeout(433, tmo)){ // each 0.433 seconds to send http request.
        HTTPC_http_client_connect(web_link.c_str());
    }
}

void my_setup_http_server(){

    uri_list+=\
        "/version\r\n"\
        "/s (for ap mode only)\r\n";

    server_p->on("/version", []() { // show version
        server_p->send(200, "text/plain", VERSION_202104270001);
    });

#if AP_MODE
    server_p->on("/s", []() {
        int i=(random(3)? -1: 1);
        static int j=0;
        static unsigned k=0;
        if (!k && random(17)>14) k=2;
        else if (k){k--; i=1;}
        j+=i;
        if (j<0) j=0;
        else if (j>7) j=7;
        ap_mode_speed_str=(j*1000+random(1000));
        server_p->send(200, "text/plain", ap_mode_speed_str.c_str());
    });
#endif
}


void init_params(){
    cDataBase s("/settings");
    s.Open();
    unsigned BootTimes=0;

    if (s.ReadWords(BootTimes, "BootTimes", 0)){
        printf("load params success: %s %u\r\n", "BootTimes", BootTimes);
    }

    s.Close();
    s.ReplaceWordsEx("BootTimes", 0, ++BootTimes);
    if (!(BootTimes%5)) s.Renew();
}


void setup(){
    ////pinMode(BUTTON_GPIO, INPUT_PULLUP);
    pinMode(BUTTON_GPIO, OUTPUT);
    digitalWrite(BUTTON_GPIO, HIGH);

    Serial.begin(115200);
    while (!Serial) delay(5);

    init_params();

    randomSeed(micros()%ESP.getChipId());

    setup_IoT();
    setup_u8g2();

    pinMode(MUX_S0_GPIO, OUTPUT);
    pinMode(MUX_S1_GPIO, OUTPUT);

    DrawSetup();
    DrawConfig(loop_u8g2_welcome);
}

unsigned welcome_wait=1;

void loop(){

    static unsigned tmo1=micros();
    if (Timeout(1500, tmo1)){
        printf("[x[%d, %d], y[%d, %d], b[%d, %d], %d[%d, %fV]]\r\n",\
        joystick[1], joystick_tri[1],\
        joystick[0], joystick_tri[0],\
        joystick[2], joystick_tri[2],\
        joystick[3], joystick_tri[3], BVOLTAGE(joystick[3]));
    }

    AutoDrawSubmit=1;

    ////static unsigned tmo0=micros();
    ////if (Timeout(the_draw_period, tmo0)) isr_draw_manip();
    isr_draw_manip();

    // after 60 seconds to power down if idle. note that webupdate before, press a button to get free time.
    static unsigned tmo2=micros();
    if (joystick_alive && !welcome_wait){
        joystick_alive=0;
        tmo2=micros();
    }
    else if (Timeout(60000, tmo2)){
        DrawEnd();
        DrawSetup();
        DrawConfig(loop_u8g2_powerdown);
        isr_draw_manip();
        digitalWrite(BUTTON_GPIO, LOW);
    }

    if (welcome_wait){
        if (welcome_wait==1){
            static unsigned y=joystick_tri[2];
            static unsigned tmoy=micros();
            if (y!=joystick_tri[2]) tmoy=micros();
            else if (Timeout(3000, tmoy)){
                if (y==joystick_tri[2]) welcome_wait=2;
            }
            y=joystick_tri[2];
        }
        else if (welcome_wait==2){
            DrawEnd();
            DrawSetup();
            DrawConfig(loop_u8g2_0);
            DrawConfig(loop_u8g2_1);
            //////////DrawConfig(loop_u8g2_2);
            DrawConfig(loop_u8g2_3);
            welcome_wait=0;
        }
        return;
    }

    static unsigned x=1;
    if (x && *remote_ap_ip){

#if STA_MODE
    /////timer_draw_manip.setTimer(DRAW_PERIOD, isr_draw_manip_timer); // reconfig timer
    the_draw_period=DRAW_PERIOD;/////
#endif

        if (!*http_request_ip) strcpy(http_request_ip, remote_ap_ip);
        web_link=String("http://")+http_request_ip+"/s";
        x=0;
    }
    loop_IoT();
}
